Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## pipe.dataLayer
Class Arc

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  pipe.dataLayer.PetriNetObject
                      pipe.dataLayer.Arc

All Implemented Interfaces:
  Constants, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable

public class Arc
extends PetriNetObject
implements Constants

Arc - Petri-Net Arc Class

Version:
  1.0
Author:
  James D Bloom
See Also:

  PNML - Petri-Net XMLSchema (stNet.xsd),

  UML - PNML Package

  , Serialized Form

Nested Class Summary

Nested classes inherited from class javax.swing.JComponent
`javax.swing.JComponent.AccessibleJComponent`

Nested classes inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary
`private ArrowHead` | `arrow` Arc is of type Line2D.Double
`private boolean` | `deleted`
`private ArcPath` | `myPath`
`private static java.awt.geom.Point2D.Double` | `point`
`private PlaceTransitionObject` | `source` references to the objects this arc connects
`private PlaceTransitionObject` | `target`
`static java.lang.String` | `type`
`private int` | `weight` Current Marking
`private NameLabel` | `weightLabel`
`private java.lang.Double` | `weightOffsetX` Initial Marking X-axis Offset
`private java.lang.Double` | `weightOffsetY` Initial Marking Y-axis Offset

Fields inherited from class pipe.dataLayer.PetriNetObject
`bounds, COMPONENT_DRAW_OFFSET, draggable, id, ignoreSelection, objectColour, pnName, selectable, selected, selectionBorderColour`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Container
``

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface pipe.gui.Constants
`ADDTOKEN, ANIMATE, ANNOTATION, ANNOTATION_DEFAULT_FONT, ANNOTATION_DEFAULT_FONT_SIZE, ANNOTATION_LAYER_OFFSET, ANNOTATION_MIN_WIDTH, ANNOTATION_SIZE_OFFSET, ARC, ARC_CONTROL_POINT_CONSTANT, ARC_LAYER_OFFSET, ARC_PATH_PROXIMITY_WIDTH, ARC_PATH_SELECTION_WIDTH, ARC_POINT_LAYER_OFFSET, CREATING, DEFAULT_ELEMENT_TYPE, DELETE, DELTOKEN, DRAW, ELEMENT_FILL_COLOUR, ELEMENT_LINE_COLOUR, ENABLED_TRANSITION_COLOUR, FIRE, GRID, IMMTRANS, LOWEST_LAYER_OFFSET, NOTE_DISABLED_COLOUR, NOTE_EDITING_COLOUR, PLACE, PLACE_TRANSITION_HEIGHT, PLACE_TRANSITION_LAYER_OFFSET, PLACE_TRANSITION_PROXIMITY_RADIUS, PROPERTY_FILE_DESC, PROPERTY_FILE_EXTENSION, RANDOM, RESERVED_BORDER, RESIZE_POINT_DOWN_COLOUR, SELECT, SELECTION_FILL_COLOUR, SELECTION_LAYER_OFFSET, SELECTION_LINE_COLOUR, START, STEPBACKWARD, STEPFORWARD, STOP, TIMEDTRANS`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`Arc(double startPositionXInput, double startPositionYInput, double endPositionXInput, double endPositionYInput)` Create Petri-Net Arc object
`Arc(double startPositionXInput, double startPositionYInput, double endPositionXInput, double endPositionYInput, PlaceTransitionObject sourceInput, PlaceTransitionObject targetInput, int weightInput, java.lang.String idInput, java.awt.Color colorInput)` Create Petri-Net Arc object
`Arc(double startPositionXInput, double startPositionYInput, double endPositionXInput, double endPositionYInput, PlaceTransitionObject sourceInput, PlaceTransitionObject targetInput, java.lang.String idInput, java.awt.Color colorInput)` Create Petri-Net Arc object
`Arc(double startPositionXInput, double startPositionYInput, double endPositionXInput, double endPositionYInput, java.lang.String idInput)` Create Petri-Net Arc object
`Arc(PlaceTransitionObject newSource)` Create Petri-Net Arc object

Method Summary
`void` | `addedToGui()`
`void` | `addWeightLabelToContainer()`
`boolean` | `contains(int x, int y)`
`void` | `delete()`
`ArcPath` | `getArcPath()`
`double` | `getEndPositionX()` Get X-axis value of end position
`double` | `getEndPositionY()` Get Y-axis value of end position
`java.lang.String` | `getId()` Get id
`PlaceTransitionObject` | `getSource()` Get source returns null if value not yet entered
`double` | `getStartPositionX()` Get X-axis value of start position
`double` | `getStartPositionY()` Get Y-axis value of start position
`PlaceTransitionObject` | `getTarget()` Get target returns null if value not yet entered
`int` | `getWeight()` Get weight
`int` | `getWeightObject()` Get weight returns null if value not yet entered
`double` | `getWeightOffsetX()` Get X-axis offset for weight position
`java.lang.Double` | `getWeightOffsetXObject()` Get X-axis offset for weight position returns null if value not yet entered
`double` | `getWeightOffsetY()` Get Y-axis offset for weight position
`java.lang.Double` | `getWeightOffsetYObject()` Get Y-axis offset for weight position returns null if value not yet entered
`void` | `paintComponent(java.awt.Graphics g)` Get Y-axis offset for inscription position returns null if value not yet entered
`void` | `setEndPoint(double x, double y, boolean type)`
`void` | `setId(java.lang.String idInput)` Set id
`void` | `setPathToTransitionAngle(int angle)`
`void` | `setSource(PlaceTransitionObject sourceInput)` Set source
`void` | `setSourceLocation(double x, double y)`
`void` | `setTarget(PlaceTransitionObject targetInput)` Set target
`void` | `setTargetLocation(double x, double y)`
`void` | `setWeight(int weightInput)` Set weight
`void` | `setWeightLabelPosition()`
`void` | `setWeightOffsetX(double weightOffsetXInput)` Set X-axis offset for weight position
`void` | `setWeightOffsetY(double weightOffsetYInput)` Set Y-axis offset for weight position
`void` | `updateArcPosition()` Updates the start position of the arc, resets the arrowhead and updates the bounds
`void` | `updateArrow()`
`void` | `updateBounds()` Updates the bounding box of the arc component based on the arcs bounds

Methods inherited from class pipe.dataLayer.PetriNetObject
`addLabelToContainer, deselect, getNameLabel, ignoreSelection, isDraggable, isSelectable, isSelected, removeFromContainer, select, setDraggable, setObjectColour, setSelectable, setSelectionBorderColour`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### type

    public static final java.lang.String type

See Also:
  Constant Field Values

### weight

    private int weight

  Current Marking

### weightOffsetX

    private java.lang.Double weightOffsetX

  Initial Marking X-axis Offset

### weightOffsetY

    private java.lang.Double weightOffsetY

  Initial Marking Y-axis Offset

### arrow

    private ArrowHead arrow

  Arc is of type Line2D.Double

### weightLabel

    private NameLabel weightLabel

### point

    private static java.awt.geom.Point2D.Double point

### source

    private PlaceTransitionObject source

  references to the objects this arc connects

### target

    private PlaceTransitionObject target

### deleted

    private boolean deleted

### myPath

    private ArcPath myPath

Constructor Detail

### Arc

    public Arc(double startPositionXInput,
               double startPositionYInput,
               double endPositionXInput,
               double endPositionYInput,
               PlaceTransitionObject sourceInput,
               PlaceTransitionObject targetInput,
               int weightInput,
               java.lang.String idInput,
               java.awt.Color colorInput)

  Create Petri-Net Arc object

Parameters:
  `startPositionXInput` - Start X-axis Position
  `startPositionYInput` - Start Y-axis Position
  `endPositionXInput` - End X-axis Position
  `endPositionYInput` - End Y-axis Position
  `sourceInput` - Arc source
  `targetInput` - Arc target
  `idInput` - Arc id
  `colorInput` - Color

### Arc

    public Arc(double startPositionXInput,
               double startPositionYInput,
               double endPositionXInput,
               double endPositionYInput,
               PlaceTransitionObject sourceInput,
               PlaceTransitionObject targetInput,
               java.lang.String idInput,
               java.awt.Color colorInput)

  Create Petri-Net Arc object

Parameters:
  `startPositionXInput` - Start X-axis Position
  `startPositionYInput` - Start Y-axis Position
  `endPositionXInput` - End X-axis Position
  `endPositionYInput` - End Y-axis Position
  `sourceInput` - Arc source
  `targetInput` - Arc target
  `idInput` - Arc id
  `colorInput` - Color

### Arc

    public Arc(double startPositionXInput,
               double startPositionYInput,
               double endPositionXInput,
               double endPositionYInput,
               java.lang.String idInput)

  Create Petri-Net Arc object

Parameters:
  `startPositionXInput` - Start X-axis Position
  `startPositionYInput` - Start Y-axis Position
  `endPositionXInput` - End X-axis Position
  `endPositionYInput` - End Y-axis Position
  `idInput` - Arc id

### Arc

    public Arc(double startPositionXInput,
               double startPositionYInput,
               double endPositionXInput,
               double endPositionYInput)

  Create Petri-Net Arc object

Parameters:
  `startPositionXInput` - Start X-axis Position
  `startPositionYInput` - Start Y-axis Position
  `endPositionXInput` - End X-axis Position
  `endPositionYInput` - End Y-axis Position

### Arc

    public Arc(PlaceTransitionObject newSource)

  Create Petri-Net Arc object

Method Detail

### setId

    public void setId(java.lang.String idInput)

  Set id

  Overrides:
    `setId` in class `PetriNetObject`
  Parameters:
    `idInput` - String value for Arc id;

### setSource

    public void setSource(PlaceTransitionObject sourceInput)

  Set source

  Parameters:
    `sourceInput` - PlaceTransitionObject value for Arc source;

### setTarget

    public void setTarget(PlaceTransitionObject targetInput)

  Set target

  Parameters:
    `targetInput` - PlaceTransitionObject value for Arc target;

### setWeight

    public void setWeight(int weightInput)

  Set weight

  Parameters:
    `weightInput` - String value for Arc weight;

### setWeightLabelPosition

    public void setWeightLabelPosition()

### addWeightLabelToContainer

    public void addWeightLabelToContainer()

### setWeightOffsetX

    public void setWeightOffsetX(double weightOffsetXInput)

  Set X-axis offset for weight position

  Parameters:
    `weightOffsetXInput` - Double value for weight X-axis offset

### setWeightOffsetY

    public void setWeightOffsetY(double weightOffsetYInput)

  Set Y-axis offset for weight position

  Parameters:
    `weightOffsetYInput` - Double value for weight Y-axis offset

### getId

    public java.lang.String getId()

  Get id

  Overrides:
    `getId` in class `PetriNetObject`
  Returns:
    String value for Arc id;

### getSource

    public PlaceTransitionObject getSource()

  Get source returns null if value not yet entered

  Returns:
    String value for Arc source;

### getTarget

    public PlaceTransitionObject getTarget()

  Get target returns null if value not yet entered

  Returns:
    String value for Arc target;

### getStartPositionX

    public double getStartPositionX()

  Get X-axis value of start position

  Returns:
    Double value for X-axis of start position

### getStartPositionY

    public double getStartPositionY()

  Get Y-axis value of start position

  Returns:
    Double value for Y-axis of start position

### getEndPositionX

    public double getEndPositionX()

  Get X-axis value of end position

  Returns:
    Double value for X-axis of end position

### getEndPositionY

    public double getEndPositionY()

  Get Y-axis value of end position

  Returns:
    Double value for Y-axis of end position

### getWeight

    public int getWeight()

  Get weight

  Returns:
    Integer value for Arc weight;

### getWeightOffsetX

    public double getWeightOffsetX()

  Get X-axis offset for weight position

  Returns:
    Double value for weight X-axis offset

### getWeightOffsetY

    public double getWeightOffsetY()

  Get Y-axis offset for weight position

  Returns:
    Double value for weight Y-axis offset

### getWeightObject

    public int getWeightObject()

  Get weight returns null if value not yet entered

  Returns:
    Integer value for Arc weight;

### getWeightOffsetXObject

    public java.lang.Double getWeightOffsetXObject()

  Get X-axis offset for weight position returns null if value not yet entered

  Returns:
    Double value for weight X-axis offset

### getWeightOffsetYObject

    public java.lang.Double getWeightOffsetYObject()

  Get Y-axis offset for weight position returns null if value not yet entered

  Returns:
    Double value for weight Y-axis offset

### paintComponent

    public void paintComponent(java.awt.Graphics g)

  Get Y-axis offset for inscription position returns null if value not yet entered

  Overrides:
    `paintComponent` in class `PetriNetObject`
  Returns:
    Double value for inscription Y-axis offset

### updateArcPosition

    public void updateArcPosition()

  Updates the start position of the arc, resets the arrowhead and updates the bounds

### updateArrow

    public void updateArrow()

### setEndPoint

    public void setEndPoint(double x,
                            double y,
                            boolean type)

### setTargetLocation

    public void setTargetLocation(double x,
                                  double y)

### setSourceLocation

    public void setSourceLocation(double x,
                                  double y)

### updateBounds

    public void updateBounds()

  Updates the bounding box of the arc component based on the arcs bounds

### getArcPath

    public ArcPath getArcPath()

### contains

    public boolean contains(int x,
                            int y)

### addedToGui

    public void addedToGui()

  Overrides:
    `addedToGui` in class `PetriNetObject`

### delete

    public void delete()

  Overrides:
    `delete` in class `PetriNetObject`

### setPathToTransitionAngle

    public void setPathToTransitionAngle(int angle)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD